//////////////////////////////////////////////////////////////////////
//                                                                  //
//  CluelessPlus - an noai-AI                                       //
//                                                                  //
//////////////////////////////////////////////////////////////////////
// 
// Author: Zuu (Leif Linse), www.zuu.info, user Zuu @ tt-forums.net
// Purpose: To play around with the noai framework.
//               - Not to make the next big thing.
// Copyright: Leif Linse - 2008, 2009
// License: GNU GPL - version 2

class Helper {
	company_name = null; // a copy of state_company_name which does not include the state-prefix that is included if one ask company.GetCompanyName();

	constructor() {
		company_name = "";
	}

	function IsStraight(tile1, tile2)
	function Distance(a, b);
	function TownDistance(town1, town2);
	function StepFunction(t);
	function ArrayFind(array, toFind);
	function TileLocationString(tile);
	function ClearAllSigns();
	function IsTownInConnectionList(connection_list, check_town);
	function Debug(text);
}

function Helper::TownDistance(town1, town2)
{
	return AIMap.DistanceManhattan(AITown.GetLocation(town1), AITown.GetLocation(town2));
}

function Helper::Distance(a, b)
{
	return AIMap.DistanceManhattan(a, b);
}

function Helper::StepFunction(t)
{
	if(t>=0)
		return 1;

	return 0;
}

function Helper::TileLocationString(tile)
{
	return "(" + AIMap.GetTileX(tile) + ", " + AIMap.GetTileY(tile) + ")";
}

function Helper::ClearAllSigns()
{
	local i = 0;
	for(i = 0; i < AISign.GetMaxSignID(); ++i)
	{
		if(i != null && AISign.IsValidSign(i))
		{
			AISign.RemoveSign(i);
		}
	}
}

function Helper::IsStraight(tile1, tile2)
{
	if(AIMap.GetTileX(tile1) == AIMap.GetTileX(tile2) ||
			AIMap.GetTileY(tile1) == AIMap.GetTileY(tile2))
	{
		return true;
	}
	return false;
}

function Helper::IsTownInConnectionList(connection_list, check_town)
{
	foreach(val in connection_list)
	{
		foreach(town in val.town)
		{
			if(town == check_town)
			{
				return true;
			}
		}
	}
	return false;
}

function Helper::Debug(text)
{
	//print(company_name + ": " + text);
	AILog.Info(text);
}

// RETURN null if not found, else the key to the found value.
function Helper::ArrayFind(array, toFind)
{
	
	foreach(key, val in array)
	{
		if(val == toFind)
		{
			return key;
		}
	}
	return null;
}
